/*
 * Created on 1 juin 2006
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.sat4j.tools;

import org.sat4j.minisat.constraints.MixedDataStructureWithBinary;
import org.sat4j.minisat.core.Solver;
import org.sat4j.minisat.orders.VarOrder;
import org.sat4j.specs.ISolver;
import org.sat4j.specs.TimeoutException;

public class SATRaceDecorator extends SolverDecorator {

    private boolean configChanged;
    private int nbvars;
    
    public SATRaceDecorator(ISolver solver) {
        super(solver);
    }

    @Override
    public int newVar(int howmany) {
        nbvars = howmany;
        return super.newVar(howmany);
    }

    
    @Override
    public void setExpectedNumberOfClauses(int nb) {
        if (nbvars>800000||nb>2000000) {
            // Use specific binary clauses representation
            System.err.println("CHANGING DATA STRUCTURES");
            Solver solver = (Solver) decorated();
            // solver.setOrder(new VarOrder());
            solver.setDataStructureFactory(new MixedDataStructureWithBinary());
            // disable solver simplification
            solver.setSimplifier(Solver.NO_SIMPLIFICATION);
            configChanged = true;
            super.newVar(nbvars);
        }

        super.setExpectedNumberOfClauses(nb);
    }

    @Override
    public boolean isSatisfiable() throws TimeoutException {
        if (configChanged) {
            System.out.println("c WARNING: used specific Binary Clause representation and disabled reason Simplification to save memory!");
        }
        return super.isSatisfiable();
    }

    
}
