/*******************************************************************************
 * Copyright (C) 2008 United States Government as represented by the
 * Administrator of the National Aeronautics and Space Administration
 * (NASA).  All Rights Reserved.
 * 
 * This software is distributed under the NASA Open Source Agreement
 * (NOSA), version 1.3.  The NOSA has been approved by the Open Source
 * Initiative.  See the file NOSA-1.3-JPF at the top of the distribution
 * directory tree for the complete NOSA document.
 * 
 * THE SUBJECT SOFTWARE IS PROVIDED "AS IS" WITHOUT ANY WARRANTY OF ANY
 * KIND, EITHER EXPRESSED, IMPLIED, OR STATUTORY, INCLUDING, BUT NOT
 * LIMITED TO, ANY WARRANTY THAT THE SUBJECT SOFTWARE WILL CONFORM TO
 * SPECIFICATIONS, ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR
 * A PARTICULAR PURPOSE, OR FREEDOM FROM INFRINGEMENT, ANY WARRANTY THAT
 * THE SUBJECT SOFTWARE WILL BE ERROR FREE, OR ANY WARRANTY THAT
 * DOCUMENTATION, IF PROVIDED, WILL CONFORM TO THE SUBJECT SOFTWARE.
 ******************************************************************************/
package jfuzz.unitTests;

import gov.nasa.jpf.util.Files;

import java.io.File;
import java.io.IOException;

import jfuzz.JFuzz;


public class AssertErrTest extends AbstractSat4jTest {
    
    //
    //  Tests
    //
    
    public void testOne() throws IOException {
        String[] args = genArgs("assert-err1.dimacs", "foo(sym)", "org.sat4j.Lanceur", 1, true);
        
        JFuzz.main(args);
        
        checkAssert();
    }
    
    public void testTwo() throws IOException {
        String[] args = genArgs("assert-err2.dimacs", "foo(sym)", "org.sat4j.Lanceur", 1, true);
        
        JFuzz.main(args);
        
        checkAssert();
    }
    
    public void testThree() throws IOException {
        String[] args = genArgs("assert-err3.dimacs", "foo(sym)", "org.sat4j.Lanceur", 1, true);
        
        JFuzz.main(args);
        
        checkAssert();
    }
    
    public void testFour() throws IOException {
        String[] args = genArgs("assert-err4.dimacs", "foo(sym)", "org.sat4j.Lanceur", 1, true);
        
        JFuzz.main(args);
        
        checkAssert();
    }
    
    private void checkAssert() throws IOException {
        checkExistIsDir(processed);
        assertEquals("Incorrect number of PCs!", 1, processed.listFiles().length);
        
        checkExistIsDir(error);
        assertEquals("Wrong Error", "java.lang.AssertionError", Files.getFileContents(new File(error, "0")));
    }
}
