/*
 * Created on 14 mars 2005
 * 
 * TODO To change the template for this generated file go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
package org.sat4j;

import static java.lang.System.out;

import org.sat4j.minisat.SolverFactory;
import org.sat4j.minisat.core.IOrder;
import org.sat4j.minisat.core.Solver;
import org.sat4j.minisat.orders.VarOrderHeapObjective;
import org.sat4j.opt.PseudoOptDecorator;
import org.sat4j.reader.OPBReader2005;
import org.sat4j.reader.OPBReader2006;
import org.sat4j.reader.ObjectiveFunction;
import org.sat4j.reader.Reader;
import org.sat4j.specs.IProblem;
import org.sat4j.specs.ISolver;
import org.sat4j.specs.TimeoutException;

/**
 * Launcher especially dedicated to the pseudo boolean 05 evaluation (@link
 * http://www.cril.univ-artois.fr/PB05/).
 * 
 * @author mederic
 */
public class LanceurPseudo2005 extends AbstractOptimizationLauncher {

    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    /**
     * Lance le prouveur sur un fichier Dimacs
     * 
     * @param args
     *            doit contenir le nom d'un fichier Dimacs, eventuellement
     *            compress?.
     */
    public static void main(String[] args) {
        AbstractLauncher lanceur = new LanceurPseudo2005();
        lanceur.run(args);
        System.exit(lanceur.getExitCode().value());
    }

    protected ObjectiveFunction obfct;

    /*
     * (non-Javadoc)
     * 
     * @see org.sat4j.Lanceur#createReader(org.sat4j.specs.ISolver)
     */
    @Override
    protected Reader createReader(ISolver solver, String problemname) {
        return new OPBReader2006(solver);
    }

    
    @Override
    protected void solve(IProblem problem) throws TimeoutException {
    	ObjectiveFunction obj = ((OPBReader2005)getReader()).getObjectiveFunction();
        ((PseudoOptDecorator)problem).setObjectTiveFunction(obj);
        IOrder order = ((Solver)((PseudoOptDecorator)problem).decorated()).getOrder();
        if (order instanceof VarOrderHeapObjective) {
        	((VarOrderHeapObjective)order).setObjectiveFunction(obj);
        }
        super.solve(problem);
    }


    /*
     * (non-Javadoc)
     * 
     * @see org.sat4j.Lanceur#configureSolver(java.lang.String[])
     */
    @Override
    protected ISolver configureSolver(String[] args) {
        ISolver solver = new PseudoOptDecorator(SolverFactory.newMiniOPBClauseCardConstrMaxSpecificOrder());//SolverFactory.newMiniOPBClauseCardMin());//
        solver.setTimeout(Integer.MAX_VALUE);
        out.println(solver.toString(COMMENT_PREFIX)); //$NON-NLS-1$
        return solver;
    }

    @Override
    protected void usage() {
        out.println("java -jar sat4jPseudo instancename.opb"); //$NON-NLS-1$
    }

    @Override
    protected String getInstanceName(String[] args) {
        assert args.length == 1;
        return args[0];
    }
}
