/*
 * Created on 23 mars 2006
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.sat4j;

import static java.lang.System.out;

import org.sat4j.minisat.SolverFactory;
import org.sat4j.opt.MaxSatDecorator;
import org.sat4j.opt.WeightedMaxSatDecorator;
import org.sat4j.reader.DimacsReader;
import org.sat4j.reader.Reader;
import org.sat4j.specs.ISolver;

public class MaxSatLauncher extends AbstractOptimizationLauncher {

    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    @Override
    protected void usage() {
        out.println("java -jar sat4jmax instance-name"); //$NON-NLS-1$
    }

    @Override
    protected Reader createReader(ISolver solver, String problemname) {
    		if (problemname.endsWith(".wcnf")) { //$NON-NLS-1$
				return new DimacsReader(solver,"wcnf"); //$NON-NLS-1$
			}
        return new DimacsReader(solver);
    }

    @Override
    protected String getInstanceName(String[] args) {
        return args[0];
    }

    @Override
    protected ISolver configureSolver(String[] args) {
    		int problemindex = args.length-1;
    		if (args[problemindex].endsWith(".wcnf")) { //$NON-NLS-1$
				return new WeightedMaxSatDecorator(SolverFactory.newMinimalOPBMinPueblo());
			}
        return new MaxSatDecorator(SolverFactory.instance().defaultSolver());
    }

    public static void main(String[] args) {
        AbstractLauncher lanceur = new MaxSatLauncher();
        lanceur.run(args);
    }
}
