package org.sat4j;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * That class is intented to manage internationalisation
 * within the application.
 * 
 * @author leberre
 *
 */
public class Messages {
	private static final String BUNDLE_NAME = "org.sat4j.messages"; //$NON-NLS-1$

	private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle
			.getBundle(BUNDLE_NAME);

    /**
     * No instances should be used.
     * Use Messages.getString(key) to get localized message for key.
     *
     */
	private Messages() {
		super();
	}

	public static String getString(String key) {
		// TODO Auto-generated method stub
		try {
			return RESOURCE_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}
}
