package org.sat4j.minisat.constraints;

import java.math.BigInteger;

import org.sat4j.minisat.constraints.pb.IDataStructurePB;
import org.sat4j.minisat.constraints.pb.MinWatchCardPB;
import org.sat4j.minisat.constraints.pb.PBConstr;
import org.sat4j.minisat.constraints.pb.PuebloMinWatchPb;
import org.sat4j.minisat.constraints.pb.WLClausePB;
import org.sat4j.specs.ContradictionException;
import org.sat4j.specs.IVec;
import org.sat4j.specs.IVecInt;

public class PuebloPBMinClauseCardConstrDataStructure extends
		AbstractPBClauseCardConstrDataStructure {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	protected PBConstr constructClause(IVecInt v) {
		return WLClausePB.brandNewClause(solver, getVocabulary(), v);
	}

	protected PBConstr constructCard(IVecInt lits, int degree)
			throws ContradictionException {
		return MinWatchCardPB.normalizedMinWatchCardPBNew(solver,
				getVocabulary(), lits, degree);
	}

	protected PBConstr constructPB(IDataStructurePB mpb)
			throws ContradictionException {
		return PuebloMinWatchPb.normalizedMinWatchPbNew(solver,
				getVocabulary(), mpb);
	}

	protected PBConstr constructLearntClause(IVecInt literals) {
		return new WLClausePB(literals, getVocabulary());
	}

	protected PBConstr constructLearntCard(IVecInt literals, int degree) {
		return new MinWatchCardPB(getVocabulary(), literals, true, degree);
	}

	protected PBConstr constructLearntPB(IVecInt literals,
			IVec<BigInteger> coefs, BigInteger degree) {
		return PuebloMinWatchPb.watchPbNew(getVocabulary(), literals, coefs,
				true, degree);
	}

}
