package org.sat4j.minisat.constraints.pb;

import java.math.BigInteger;

import org.sat4j.minisat.core.ILits;

public class ConflictArrayClause extends ConflictArray {

	public ConflictArrayClause(int[] lits, BigInteger[] coefs, BigInteger d,
			ILits voc) {
		super(lits, coefs, d, voc);
	}

	public static IConflict createConflict(PBConstr cpb) {
		return new ConflictArrayClause(cpb.getLits(), cpb.getCoefs(), cpb
				.getDegree(), cpb.getVocabulary());
	}

	/**
	 * reduces the constraint defined by wpb until the result of the cutting
	 * plane is a conflict. this reduction returns a clause.
	 * 
	 * @param litImplied
	 * @param ind
	 * @param reducedCoefs
	 * @param wpb
	 * @return
	 */
	protected BigInteger reduceUntilConflict(int litImplied, int ind,
			BigInteger[] reducedCoefs, WatchPb wpb) {
		for (int i = 0; i < reducedCoefs.length; i++)
			if (i == ind || wpb.getVocabulary().isFalsified(wpb.get(i)))
				reducedCoefs[i] = BigInteger.ONE;
			else
				reducedCoefs[i] = BigInteger.ZERO;
		coefMultCons = coefs[litImplied ^ 1];
		coefMult = BigInteger.ONE;
		return BigInteger.ONE;
	}
}
