package org.sat4j.minisat.constraints.pb;

import java.math.BigInteger;

public interface IConflict extends IDataStructurePB {
	
	/**
	 * Effectue une resolution avec une contrainte PB. Met a jour le Conflict.
	 * 
	 * @param cpb
	 *            contrainte avec laquelle on va faire la resolution
	 * @param litImplied
	 *            litteral devant etre resolu
	 * @return la mise a jour du degre
	 */
	BigInteger resolve(PBConstr cpb, int litImplied);


	BigInteger slackConflict() ;

	boolean isAssertive(int dl);


	/**
	 * Reduction d'une contrainte On supprime un litteral non assigne
	 * prioritairement, vrai sinon. En aucun cas on ne supprime litImplied.
	 * 
	 * @return mise a jour du degre
	 */
	public BigInteger reduceInConstraint(WatchPb wpb,
			final BigInteger[] coefsBis, final int indLitImplied,
			final BigInteger degreeBis);

	/**
	 * retourne le niveau de backtrack : c'est-?-dire le niveau le plus haut
	 * pour lequel la contrainte est assertive
	 * 
	 * @param maxLevel
	 *            le plus bas niveau pour lequel la contrainte est assertive
	 * @return the highest level (smaller int) for which the constraint is
	 *         assertive.
	 */
	public int getBacktrackLevel(int maxLevel);

}
