package org.sat4j.minisat.constraints.pb;

import java.math.BigInteger;

import org.sat4j.specs.IVec;
import org.sat4j.specs.IVecInt;

public interface IDataStructurePB {
	BigInteger saturation();
	
	BigInteger cuttingPlane(PBConstr cpb, BigInteger deg,
			BigInteger[] reducedCoefs);

	BigInteger cuttingPlane(PBConstr cpb, BigInteger degreeCons,
			BigInteger[] reducedCoefs, BigInteger coefMult);

	BigInteger cuttingPlane(int[] lits, BigInteger[] reducedCoefs,
			BigInteger deg);

	BigInteger cuttingPlane(int lits[], BigInteger[] reducedCoefs,
			BigInteger degreeCons, BigInteger coefMult);

	void buildConstraintFromConflict(IVecInt resLits, IVec<BigInteger> resCoefs);

	public void buildConstraintFromMapPb(int[] resLits, BigInteger[] resCoefs);

	public BigInteger getDegree();


	public int size();



}
