package org.sat4j.minisat.constraints.pb;

import java.math.BigInteger;

import org.sat4j.minisat.constraints.cnf.MixableCBClause;
import org.sat4j.minisat.core.ILits;
import org.sat4j.minisat.core.UnitPropagationListener;
import org.sat4j.specs.IVecInt;

public class MixableCBClausePB extends MixableCBClause implements PBConstr{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public MixableCBClausePB(IVecInt ps, ILits voc, boolean learnt) {
		super(ps, voc, learnt);
	}

	public MixableCBClausePB(IVecInt ps, ILits voc) {
		super(ps, voc);
	}

    public static MixableCBClausePB brandNewClause(UnitPropagationListener s, ILits voc,
            IVecInt literals) {
        MixableCBClausePB c = new MixableCBClausePB(literals, voc);
        c.register();
        return c;
    }


	
	/* (non-Javadoc)
	 * @see org.sat4j.minisat.constraints.pb.PBConstr#computeAnImpliedClause()
	 */
	public IVecInt computeAnImpliedClause() {
		return null;
	}

	/* (non-Javadoc)
	 * @see org.sat4j.minisat.constraints.pb.PBConstr#getCoef(int)
	 */
	public BigInteger getCoef(int literal) {
		return BigInteger.ONE;
	}

	/* (non-Javadoc)
	 * @see org.sat4j.minisat.constraints.pb.PBConstr#getCoefs()
	 */
	public BigInteger[] getCoefs() {
		BigInteger[] tmp = new BigInteger[size()];
		for (int i = 0; i < tmp.length; i++)
			tmp[i] = BigInteger.ONE;
		return tmp;
	}

	/* (non-Javadoc)
	 * @see org.sat4j.minisat.constraints.pb.PBConstr#getDegree()
	 */
	public BigInteger getDegree() {
		return BigInteger.ONE;	
	}

	/* (non-Javadoc)
	 * @see org.sat4j.minisat.constraints.pb.PBConstr#getLits()
	 */
	public int[] getLits() {
		int[] tmp = new int[size()];
		System.arraycopy(lits, 0, tmp, 0, size());
		return tmp;
	}

	/* (non-Javadoc)
	 * @see org.sat4j.minisat.constraints.pb.PBConstr#getVocabulary()
	 */
	public ILits getVocabulary() {
		return voc;
	}
	
    /*
     * (non-Javadoc)
     * 
     * @see org.sat4j.minisat.core.Constr#assertConstraint(org.sat4j.minisat.core.UnitPropagationListener)
     */
    public void assertConstraint(UnitPropagationListener s) {
		for (int i = 0; i < size(); i++)
			if (getVocabulary().isUnassigned(get(i))) {
				boolean ret = s.enqueue(get(i), this);
				assert ret;
				break;
			}
    }


}
