package org.sat4j.minisat.constraints.pb;

import java.math.BigInteger;

import org.sat4j.minisat.core.AssertingClauseGenerator;
import org.sat4j.minisat.core.DataStructureFactory;
import org.sat4j.minisat.core.IOrder;
import org.sat4j.minisat.core.LearningStrategy;
import org.sat4j.specs.ContradictionException;
import org.sat4j.specs.IConstr;
import org.sat4j.specs.IVec;
import org.sat4j.specs.IVecInt;

public class PBSolverWithImpliedClause extends PBSolver {

	public PBSolverWithImpliedClause(AssertingClauseGenerator acg,
			LearningStrategy learner, DataStructureFactory dsf, IOrder order) {
		super(acg, learner, dsf, order);
	}

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public IConstr addPseudoBoolean(IVecInt literals, IVec<BigInteger> coeffs,
			boolean moreThan, BigInteger degree) throws ContradictionException {
		IVecInt vlits = dimacs2internal(literals);
		assert vlits.size() == literals.size();
		assert literals.size() == coeffs.size();
		PBConstr result = (PBConstr) dsfactory.createPseudoBooleanConstraint(
				vlits, coeffs, moreThan, degree);
		if (result != null) {
			IVecInt clits = result.computeAnImpliedClause();
			if (clits != null) {
				addConstr(dsfactory.createClause(clits));
			}
		}
		return addConstr(result);
	}

    @Override
    public String toString(String prefix) {
        return super.toString(prefix)+"\n"+prefix+"Add implied clauses in preprocessing";
    }
}
