package org.sat4j.minisat.orders;

import static org.sat4j.minisat.core.LiteralsUtils.neg;
import static org.sat4j.minisat.core.LiteralsUtils.var;

import java.math.BigInteger;

import org.sat4j.reader.ObjectiveFunction;
import org.sat4j.specs.IVec;
import org.sat4j.specs.IVecInt;

public class VarOrderHeapObjective extends VarOrderHeap {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private ObjectiveFunction obj;

	public void setObjectiveFunction(ObjectiveFunction obj) {
		this.obj = obj;
	}

	@Override
	public void init() {
		super.init();
		if (obj != null) {
			IVecInt vars = obj.getVars();
			IVec<BigInteger> coefs = obj.getCoeffs();
			for (int i = 0; i < vars.size(); i++) {
				int p = lits.getFromPool(vars.get(i));
				BigInteger c = coefs.get(i);
				if (c.signum() < 0) {
					p = neg(p);
				}
				int var = var(p);
				activity[var] = c.abs().doubleValue();
				if (heap.inHeap(var))
					heap.increase(var);
				phase[var] = neg(p);
			}
		}
	}
}
