/*
 * Created on 23 mars 2006
 * 
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.sat4j.opt;

import org.sat4j.core.VecInt;
import org.sat4j.specs.ContradictionException;
import org.sat4j.specs.IConstr;
import org.sat4j.specs.IOptimizationProblem;
import org.sat4j.specs.ISolver;
import org.sat4j.specs.IVecInt;
import org.sat4j.specs.TimeoutException;
import org.sat4j.tools.SolverDecorator;

public class MaxSatDecorator extends SolverDecorator implements
        IOptimizationProblem {

    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    private int nborigvars;

    private int nbexpectedclauses;

    private int nbnewvar;

    private int[] prevfullmodel;

    public MaxSatDecorator(ISolver solver) {
        super(solver);
    }

    @Override
    public int[] model() {
        int[] shortmodel = new int[nborigvars];
        for (int i = 0; i < nborigvars; i++) {
            shortmodel[i] = prevfullmodel[i];
        }
        return shortmodel;
    }

    @Override
    public int newVar(int howmany) {
        nborigvars = super.newVar(howmany);
        return nborigvars;
    }

    @Override
    public void setExpectedNumberOfClauses(int nb) {
        nbexpectedclauses = nb;
        super.setExpectedNumberOfClauses(nb);
        super.newVar(nborigvars + nbexpectedclauses);
    }

    @Override
    public IConstr addClause(IVecInt literals) throws ContradictionException {
        literals.push(nborigvars + ++nbnewvar);
        return super.addClause(literals);
    }

    @Override
    public void reset() {
        nbnewvar = 0;
        vec.clear();
        super.reset();
    }

    public boolean admitABetterSolution() throws TimeoutException {
        boolean result = super.isSatisfiable();
        if (result)
            prevfullmodel = super.model();
        return result;
    }

    public boolean hasNoObjectiveFunction() {
        return false;
    }

    public boolean nonOptimalMeansSatisfiable() {
        return false;
    }

    public Number calculateObjective() {
        counter = 0;
        for (int q : prevfullmodel) {
            if (q > nborigvars) {
                counter++;
            }
        }
        return counter;
    }

    private final IVecInt vec = new VecInt();

    private int counter;

    public void discard() throws ContradictionException {
        if (vec.isEmpty()) {
            for (int i = nborigvars + 1; i <= nVars(); i++) {
                vec.push(i);
            }
        }
        super.addAtMost(vec, counter - 1);
    }

}
