/*
 * Created on 29 mars 2006
 * 
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.sat4j.opt;

import java.math.BigInteger;

import org.sat4j.reader.ObjectiveFunction;
import org.sat4j.specs.ContradictionException;
import org.sat4j.specs.IOptimizationProblem;
import org.sat4j.specs.ISolver;
import org.sat4j.specs.TimeoutException;
import org.sat4j.tools.SolverDecorator;

public class PseudoOptDecorator extends SolverDecorator implements
		IOptimizationProblem {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private ObjectiveFunction objfct;

	private int[] prevmodel;

	public PseudoOptDecorator(ISolver solver) {
		super(solver);
	}

	public void setObjectTiveFunction(ObjectiveFunction objf) {
		objfct = objf;
	}

	public boolean admitABetterSolution() throws TimeoutException {
		boolean result = super.isSatisfiable();
		if (result)
			prevmodel = super.model();
		return result;
	}

	public boolean hasNoObjectiveFunction() {
		return objfct == null;
	}

	public boolean nonOptimalMeansSatisfiable() {
		return true;
	}

	public Number calculateObjective() {
		return objfct.calculateDegree(prevmodel);
	}

	public void discard() throws ContradictionException {
		super.addPseudoBoolean(objfct.getVars(), objfct.getCoeffs(), false,
				objfct.calculateDegree(prevmodel).subtract(BigInteger.ONE));
	}

	@Override
	public int[] model() {
		return prevmodel;
	}

}
