package org.sat4j.reader;

import org.sat4j.reader.csp.BinarySupportsACEncoding;
import org.sat4j.reader.csp.SupportsDirectEncoding;
import org.sat4j.specs.ISolver;

public class CSPSupportReader extends CSPReader {
    
    public CSPSupportReader(ISolver solver) {
        super(solver);
    }

    @Override
    protected void manageAllowedTuples(int relnum, int[] domains, int nbtuples) {
        if (domains.length==2)
            relations[relnum] = new BinarySupportsACEncoding(domains, nbtuples);
        else 
            relations[relnum] = new SupportsDirectEncoding(domains, nbtuples);
    }
}