package org.sat4j.reader.csp;


import org.sat4j.core.VecInt;
import org.sat4j.specs.ContradictionException;
import org.sat4j.specs.ISolver;
import org.sat4j.specs.IVecInt;


public class Nogoods implements Relation {

    private final int[] domains;

    private int[][] tuples;

    public Nogoods(int[] domains, int nbtuples) {
        this.domains = domains;
        tuples = new int[nbtuples][];
    }

    public void addTuple(int index, int[] tuple) {
        tuples[index] = tuple;
    }

    public void toClause(ISolver solver, Var[] vars)
            throws ContradictionException {
        IVecInt clause = new VecInt();
        for (int i = 0; i < tuples.length; i++) {
            clause.clear();
            for (int j = 0; j < domains.length; j++) {
                clause.push(-vars[j].translate(tuples[i][j]));
            }
            // System.err.println("Adding clause (EZ) :" + clause);
            solver.addClause(clause);
        }
    }

    public int arity() {
        return domains.length;
    }
}