package org.sat4j.reader.csp;

import java.util.HashMap;
import java.util.Map;

import org.sat4j.core.VecInt;
import org.sat4j.specs.ContradictionException;
import org.sat4j.specs.ISolver;
import org.sat4j.specs.IVecInt;


public class Var {

    Map<Integer, Integer> mapping = new HashMap<Integer, Integer>();

    private final int[] domain;

    public Var(int[] domain, int startid) {
        this.domain = domain;
        for (int i = 0; i < domain.length; i++)
            mapping.put(domain[i], ++startid);
    }

    public int[] domain() {
        return domain;
    }

    public int translate(int key) {
        return mapping.get(key);
    }

    public void toClause(ISolver solver) throws ContradictionException {
        IVecInt clause = new VecInt();
        for (int v : mapping.values())
            clause.push(v);
        solver.addClause(clause);
        solver.addAtMost(clause, 1);
    }

    public int findValue(int[] model) {
        for (Map.Entry<Integer, Integer> entry : mapping.entrySet()) {
            if ( model[entry.getValue()-1]==entry.getValue())
                    return entry.getKey();
        }
        throw new RuntimeException("BIG PROBLEM: no value for a var!");
    }
}